/* This file is part of the 
 *
 *	Delta Project  (ConversationBuilder)  
 *	Human-Computer Interaction Laboratory
 *	University of Illinois at Urbana-Champaign
 *	Department of Computer Science
 *	1304 W. Springfield Avenue
 *	Urbana, Illinois 61801
 *	USA
 *
 *	c 1989,1990,1991 Board of Trustees
 *		University of Illinois
 *		All Rights Reserved
 *
 *	This file is distributed under license and is confidential
 *
 *	File title and purpose
 *	Author:	 Mark Allender (allender@cs.uiuc.edu)
 *
 *	Project Leader:  Simon Kaplan (kaplan@cs.uiuc.edu)
 *	Direct enquiries to the project leader please.
 */

#include "extern.h"
#include <stdio.h>
#include <X11/X.h>
#include <X11/Xlib.h>
#include <X11/Xutil.h>
#include <X11/Intrinsic.h>
#include "cb.xbm"

/*
 *  Simple routine to set up the pixmap data for the icon.  It is
 *  attached to the widget that is sent in.
*/
void
SetPixmap(widget)
     Widget widget;
{
  Arg args[2];
  Pixmap icon_map;
  int n;

  icon_map = XCreateBitmapFromData(XtDisplay(widget),
				   XtScreen(widget)->root,
				   cb_bits,
				   cb_width,
				   cb_height);
  n = 0;
  if (icon_map != 0) {
    XtSetArg(args[0], XtNiconPixmap, icon_map); n++;
    XtSetValues(widget, args, n);
  }
}
